#include <Wire.h>   ////Biblioteca que possibilita a comunicação i2c
#include <LiquidCrystal_I2C.h>  //Biblioteca do lcd i2c
LiquidCrystal_I2C lcd(0x27,20,4);  //Converte o LCD  adress 0x27 para 16 colunas e 2 linhas

//Associa cada pino analógico à variável da cor correspondente 
#define cor1 A0
#define cor2 A1
#define cor3 A2
#define cor4 A3

//Varaveis temporárias
int estado_cor1, estado_cor2, estado_cor3, estado_cor4;
int valor_cor1, valor_cor2, valor_cor3, valor_cor4;

void setup() {
  lcd.init();
  lcd.backlight();
  lcd.setCursor(1, 0);
  lcd.print("CALCULADORA DE");
  lcd.setCursor(2, 1);
  lcd.print("RESISTENCIAS");
  pinMode(cor1, INPUT);
  pinMode(cor2, INPUT);
  pinMode(cor3, INPUT);
  pinMode(cor4, INPUT);
  delay(3000);
  lcd.clear();
  //Escreve no LCD texto inicial e simbolos estáticos
  lcd.setCursor(0, 0);
  lcd.print("DESENVOLVIDO POR");
  lcd.setCursor(1, 1);
  lcd.print("NUNO  MONTEIRO");
  delay(3000);
  lcd.clear();
  simboloohm();
  lcd.setCursor(11, 1);
  lcd.write(1);
  simboloR1();
  lcd.setCursor(0, 0);
  lcd.write(2);
  simboloR();
  lcd.setCursor(1, 0);
  lcd.write(3);
  simboloR();
  lcd.setCursor(4, 0);
  lcd.write(3);
  simboloR();
  lcd.setCursor(7, 0);
  lcd.write(3);
  simboloR();
  lcd.setCursor(10, 0);
  lcd.write(3);
  simboloR();
  lcd.setCursor(11, 0);
  lcd.write(3);
  simboloR();
  lcd.setCursor(14, 0);
  lcd.write(3);
  simboloR11();
  lcd.setCursor(15, 0);
  lcd.write(4);
  simbolomaismenos();
  lcd.setCursor(12, 1);
  lcd.write(5);
  lcd.setCursor(0, 1);
  lcd.print("VALOR:");
}

void loop() {
  // lê o estado de cada potenciometro (cor de cada lista)
  estado_cor1 = analogRead(cor1);
  estado_cor2 = analogRead(cor2);
  estado_cor3 = analogRead(cor3);
  estado_cor4 = analogRead(cor4);

  //mapea as cores para cada cor 
  valor_cor1 = map(estado_cor1, 0, 1023, 0, 10);
  valor_cor2 = map(estado_cor2, 0, 1023, 0, 10);
  valor_cor3 = map(estado_cor3, 0, 1023, 0, 9);
  valor_cor4 = map(estado_cor4, 0, 1023, 0, 4);

  switch (valor_cor1) { //Verifica a cor 1 selecionada e mostra no LCD
    case 0:    //1ª cor - Preto
      lcd.setCursor(2, 0);
      lcd.print("PO");
      lcd.setCursor(6, 1);
      lcd.print("0");
      break;
    case 1:    //1ª cor - Castanho
      lcd.setCursor(2, 0);
      lcd.print("CA");
      lcd.setCursor(6, 1);
      lcd.print("1");
      break;
    case 2:    //1ª cor - Vermelho
      lcd.setCursor(2, 0);
      lcd.print("VO");
      lcd.setCursor(6, 1);
      lcd.print("2");
      break;
    case 3:    //1ª cor - Laranja
      lcd.setCursor(2, 0);
      lcd.print("LA");
      lcd.setCursor(6, 1);
      lcd.print("3");
      break;
    case 4:    //1ª cor - Amarelo
      lcd.setCursor(2, 0);
      lcd.print("AM");
      lcd.setCursor(6, 1);
      lcd.print("4");
      break;
    case 5:    //1ª cor - Verde
    lcd.setCursor(2, 0);
      lcd.print("VE");
      lcd.setCursor(6, 1);
      lcd.print("5");
      break;
    case 6:    //1ª cor - Azul
      lcd.setCursor(2, 0);
      lcd.print("AZ");
      lcd.setCursor(6, 1);
      lcd.print("6");
      break;
    case 7:    //1ª cor - Violeta
      lcd.setCursor(2, 0);
      lcd.print("VI");
      lcd.setCursor(6, 1);
      lcd.print("7");
      break;
    case 8:    //1ª cor - Cizento
      lcd.setCursor(2, 0);
      lcd.print("CI");
      lcd.setCursor(6, 1);
      lcd.print("8");
      break;
    case 9:    //1ª cor - Branco
      lcd.setCursor(2, 0);
      lcd.print("BR");
      lcd.setCursor(6, 1);
      lcd.print("9");
      break;
    case 10:    //1ª cor - Branco
      lcd.setCursor(1, 1);
      lcd.print("B");
      lcd.setCursor(6, 1);
      lcd.print("9");
      break;
  }
  delay(10);

  switch (valor_cor2) { //Verifica a cor 2 selecionada e mostra no LCD
    case 0:    //2ª cor - Preto
      lcd.setCursor(5, 0);
      lcd.print("PO");
      lcd.setCursor(7, 1);
      lcd.print("0");
      break;
    case 1:    //2ª cor - Castanho
      lcd.setCursor(5, 0);
      lcd.print("CA");
      lcd.setCursor(7, 1);
      lcd.print("1");
      break;
    case 2:    //2ª cor - Vermelho
      lcd.setCursor(5, 0);
      lcd.print("VO");
      lcd.setCursor(7, 1);
      lcd.print("2");
      break;
    case 3:    //2ª cor - Laranja
      lcd.setCursor(5, 0);
      lcd.print("LA");
      lcd.setCursor(7, 1);
      lcd.print("3");
      break;
    case 4:    //2ª cor - Amarelo
      lcd.setCursor(5, 0);
      lcd.print("AM");
      lcd.setCursor(7, 1);
      lcd.print("4");
      break;
    case 5:    //2ª cor - Verde
      lcd.setCursor(5, 0);
      lcd.print("VE");
      lcd.setCursor(7, 1);
      lcd.print("5");
      break;
    case 6:    //2ª cor - Azul
      lcd.setCursor(5, 0);
      lcd.print("AZ");
      lcd.setCursor(7, 1);
      lcd.print("6");
      break;
    case 7:    //2ª cor - Violeta
      lcd.setCursor(5, 0);
      lcd.print("VI");
      lcd.setCursor(7, 1);
      lcd.print("7");
      break;
    case 8:    //2ª cor - Cizento
      lcd.setCursor(5, 0);
      lcd.print("CI");
      lcd.setCursor(7, 1);
      lcd.print("8");
      break;
    case 9:    //2ª cor - Branco
      lcd.setCursor(5, 0);
      lcd.print("BR");
      lcd.setCursor(7, 1);
      lcd.print("9");
      break;
    case 10:    //2ª cor - Branco
      lcd.setCursor(5, 0);
      lcd.print("BR");
      lcd.setCursor(7, 1);
      lcd.print("9");
      break;
  }
  delay(10);

  switch (valor_cor3) {  //Verifica a cor 3 selecionada e mostra no LCD
    case 0:    //3ª cor - Preto
      lcd.setCursor(8, 0);
      lcd.print("PO");
      lcd.setCursor(8, 1);
      lcd.print("   ");
      break;
    case 1:    //3ª cor - Castanho
      lcd.setCursor(8, 0);
      lcd.print("CA");
      lcd.setCursor(8, 1);
      lcd.print("0  ");

      break;
    case 2:    //3ª cor - Vermelho
      lcd.setCursor(8, 0);
      lcd.print("VO");
      lcd.setCursor(8, 1);
      lcd.print("00 ");
      break;
    case 3:    //3ª cor - Laranja
      lcd.setCursor(8, 0);
      lcd.print("LA");
      lcd.setCursor(8, 1);
      lcd.print("K  ");
      break;
    case 4:    //3ª cor - Amarelo
      lcd.setCursor(8, 0);
      lcd.print("AM");
      lcd.setCursor(8, 1);
      lcd.print("0K ");
      break;
    case 5:    //3ª cor - Verde
      lcd.setCursor(8, 0);
      lcd.print("VE");
      lcd.setCursor(8, 1);
      lcd.print("00K");
      break;
    case 6:    //3ª cor - Azul
      lcd.setCursor(8, 0);
      lcd.print("AZ");
      lcd.setCursor(8, 1);
      lcd.print("M  ");
      break;
    case 7:    //3ª cor - Violeta
      lcd.setCursor(8, 0);
      lcd.print("VI");
      lcd.setCursor(8, 1);
      lcd.print("0M ");
      break;
    case 8:    //3ª cor - Violeta
      lcd.setCursor(8, 0);
      lcd.print("VI");
      lcd.setCursor(8, 1);
      lcd.print("0M ");
      break;
  }
  delay(10);

  switch (valor_cor4) {   //Verifica a cor 4 selecionada e mostra no LCD
    case 0:    //4ª cor - Castanho
      lcd.setCursor(12, 0);
      lcd.print("CA");
      lcd.setCursor(13, 1);
      lcd.print(" 1%");
      break;
    case 1:    //4ª cor - Vermelho
      lcd.setCursor(12, 0);
      lcd.print("VO");
      lcd.setCursor(13, 1);
      lcd.print(" 2%");
      break;
    case 2:    //4ª cor - Ouro
      lcd.setCursor(12, 0);
      lcd.print("OU");
      lcd.setCursor(13, 1);
      lcd.print(" 5%");
      break;
    case 3:    //4ª cor - Prata
      lcd.setCursor(12, 0);
      lcd.print("PA");
      lcd.setCursor(13, 1);
      lcd.print("10% ");
      break;
    case 4:    //4ª cor - Prata
      lcd.setCursor(12, 0);
      lcd.print("PA");
      lcd.setCursor(13, 1);
      lcd.print("10% ");
      break;
  }
  delay(10);
}

//Funções dos simbolos da resistência, ohm e +/- 
void simboloohm() {
  byte ohm[8] = {
    B00000,
    B00000,
    B01110,
    B10001,
    B10001,
    B01010,
    B11011,
    B00000
  };
  lcd.createChar(1, ohm);
}

void simboloR1() {
  byte R1[8] = {
    B00001,
    B00001,
    B00001,
    B11111,
    B11111,
    B00001,
    B00001,
    B00001
  };
  lcd.createChar(2, R1);
}

void simboloR() {
  byte Rbr[8] = {
    B11111,
    B00000,
    B00000,
    B00000,
    B00000,
    B00000,
    B00000,
    B11111
  };
  lcd.createChar(3, Rbr);
}

void simboloR11() {
  byte R11[8] = {
    B10000,
    B10000,
    B10000,
    B11111,
    B11111,
    B10000,
    B10000,
    B10000
  };
  lcd.createChar(4, R11);
}

void simbolomaismenos() {
  byte maismenos[8] = {
    B00100,
    B00100,
    B11111,
    B00100,
    B00100,
    B00000,
    B11111,
    B00000
  };
  lcd.createChar(5, maismenos);
}
